//LangueCopieGroupe_506f.js
// 09.11.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Copie le groupe de styles de paragraphes ou de caractres, modifie la langue des styles et les applique aux textes du calque slectionn

// activer l'affichage de dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// une rfrence au premier document
var curDoc = app.documents[0];

// lister les noms des calques
var allLayers = curDoc.layers.everyItem().name;

// mmoriser le calque actif
var curLayer = app.activeWindow.activeLayer.index;

// vrifier s'il existent des groupes de styles de paragraphes
paraGroups = curDoc.paragraphStyleGroups;
var nPSG = paraGroups.length;

// vrifier s'il existent des groupes de styles de caractres
charGroups = curDoc.characterStyleGroups;
var nCSG = charGroups.length;

//--- dresser la liste des noms des groupes de styles de paragraphes ---//
var noParaStyles = false;
if (nPSG == 0) {
	var pRoot = true;
	// lister les styles de paragraphes
	var allParaStyles = curDoc.paragraphStyles;
	var nAllPara = allParaStyles.length;
	if (nAllPara >2) {
		// un lment vide et le nom par dfaut du "groupe"
		paraGroups =  new Array ("[Root]");
		pGroupNames = new Array ("", "[Root]");
		nPSG = 2;
	}
	else {
		// il n'y a pas de styles de paragraphe
		noParaStyles = true;
	}
}
else {
	var pRoot = false;
	pGroupNames = paraGroups.everyItem().name;
	// insrer un lment vide au dbut
	pGroupNames = [""].concat(pGroupNames);
	nPSG++;
}

//--- dresser la liste des noms des groupes de styles de caractres ---//
var noCharStyles = false;
if (nCSG == 0) {
	var cRoot = true;
	var allCharStyles = curDoc.characterStyles;
	var nAllChar = allCharStyles.length;
	if (nAllChar >1) {
		// un lment vide et le nom par dfaut du "groupe"
		charGroups =  new Array ("[Root]");
		cGroupNames = new Array ("", "[Root]");
		nCSG = 2;
	}
	else {
		// il n'y a pas de styles de caractres
		noCharStyles = true;
	}
}
else {
	var cRoot = false;
	cGroupNames = charGroups.everyItem().name;
	// insrer un lment vide au dbut
	cGroupNames = [""].concat(cGroupNames);
	nCSG++;
}
// s'il n'y a pas de groupes: tester s'il y a des styles
if (noParaStyles && noCharStyles) {
		alert ("Il n'y a pas de styles dfinis par l'utilisateur.", "Stop");
	exit();
}

// les listes des langues disponibles
var allLang = app.languagesWithVendors;
var lngNameList = app.languagesWithVendors.everyItem().name;
var locLangList = app.languagesWithVendors.everyItem().name;
locLangList.sort();
var noLang = locLangList.pop();
locLangList.unshift(noLang);

// lire le fichier dans lequel le dernier choix est mmoris
var langDef = "";
if ($.os.slice(0,7) == "Windows") {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/LangCopyGroup_506.txt");
}
else {
	var f = new File("~/Library/Preferences/LangCopyGroup_506.txt");
}
var fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		langDef = (f.read());
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}
// extraire les valeurs mmoriss
if (langDef != "") {
	var defVal = langDef.split("\n");
	oldPara = defVal[0];
	newParaGroupName = defVal[1];
	pCop = defVal[2];
	if (pCop == "false") { pCop = false; pMov = true; }
	else {pCop = true; pMov = false;}
	oldChar = defVal[3];
	newCharGroupName = defVal[4];
	cCop = defVal[5];
	if (cCop == "false") { cCop = false; cMov = true; }
	else {cCop = true; cMov = false;}
	curLang = (defVal[6])*1;
	nFrc = defVal[7];
	if (nFrc == "true") { nFrc = true; dFrc = false; }
	else { dFrc = true; nFrc = false; }
	curLayer = defVal[8]*1;
	newLayerName = defVal[9];
	newLayerColorID = defVal[10]*1;
}
else {
	var newParaGroupName = newCharGroupName = "";
	var pCop = cCop = dFrc = true;
	var pMov = cMov = nFrc = false;
	var curLang = 1;
	var cSel = pSel = 0;
	var oldChar = oldPara = "";
	var curLayer = 0;
	var newLayerName = "";
	var newLayerColorID = 1;
}

// mmoriser l'index des anciens noms de groupe
if (nPSG == 2) {
	pSel = 1;
}
else if (nPSG != 0) {
	for (var p=1; p<nPSG; p++) {
		curGrp = pGroupNames[p];
		if (oldPara == curGrp) {
			pSel = p;
			break;
		}
	}
}
if (nCSG == 0) {
	cSel = 0;
}
if (nCSG == 1) {
	cSel = 0;
}
else if (nCSG == 2) {
	cSel = 1;
}
else if (nCSG != 0) {
	for (var i=1; i<nCSG; i++) {
		curGrp = cGroupNames[i];
		if (oldChar == curGrp) {
			cSel = i;
			break;
		}
	}
}

// la liste des noms des couleurs des calques en franais
var layerColors = new Array("Bleu clair", "Rouge", "Vert", "Bleu", "Jaune", "Magenta", "Cyan", 
"Gris", "Noir", "Orange", "Vert fonc", "Bleu-vert", "Brun roux", "Marron", "Violet", "Or", 
"Bleu fonc", "Rose", "Lavande", "Rouge brique", "Vert olive", "Pche", "Bordeaux", "Vert anis", 
"Ocre", "Pourpre", "Gris clair", "Anthracite", "Grille bleue", "Grille orange", "Rouge vif", 
"Olive clair", "Rouge  lvres", "Bleu-vert", "Soufre", "Grille verte", "Blanc");

// la liste des noms des couleurs UI correspondants
var uiColors = new Array(UIColors.LIGHT_BLUE, UIColors.RED, UIColors.GREEN, UIColors.BLUE, 
UIColors.YELLOW, UIColors.MAGENTA, UIColors.CYAN, UIColors.GRAY, UIColors.BLACK, UIColors.ORANGE, 
UIColors.DARK_GREEN, UIColors.TEAL, UIColors.TAN, UIColors.BROWN, UIColors.VIOLET, UIColors.GOLD, 
UIColors.DARK_BLUE, UIColors.PINK, UIColors.LAVENDER, UIColors.BRICK_RED, UIColors.OLIVE_GREEN, 
UIColors.PEACH, UIColors.BURGUNDY, UIColors.GRASS_GREEN, UIColors.OCHRE, UIColors.PURPLE, UIColors.LIGHT_GRAY, 
UIColors.CHARCOAL, UIColors.GRID_BLUE, UIColors.GRID_ORANGE, UIColors.FIESTA, UIColors.LIGHT_OLIVE, 
UIColors.LIPSTICK, UIColors.CUTE_TEAL, UIColors.SULPHUR, UIColors.GRID_GREEN, UIColors.WHITE);

// effacer des dialogues, rests ventuellement dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// prparer le dialogue
var aDialog = app.dialogs.add({name:"Slectionner les groupes, la langue et le calque", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		if (noParaStyles == false) {
			with (dialogRows.add()) {
				if (!pRoot) {
					staticTexts.add({staticLabel:"Copier le groupe de styles de paragraphes:"});
					staticTexts.add({staticLabel:" "});
				}
				else {
					staticTexts.add({staticLabel:"Styles de paragraphes"});
					staticTexts.add({staticLabel:" "});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var paraGroup = dropdowns.add({stringList:pGroupNames, selectedIndex:pSel, minWidth:220});
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:40});
						staticTexts.add({staticLabel:"Le nom du nouveau groupe:"});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:40});
						var paraName = textEditboxes.add({editContents:newParaGroupName, minWidth:224});
						staticTexts.add({staticLabel:" "});
					}
					if (pRoot) {
						var pButtons = radiobuttonGroups.add();
						with (pButtons) {
							radiobuttonControls.add({staticLabel:"*copier* les styles dans le nouveau groupe", checkedState:pCop});
							radiobuttonControls.add({staticLabel:"*dplacer* les styles dans le nouveau groupe", checkedState:pMov});
						}
					}
				}
			}
		}
		if (noCharStyles == false) {
			with (dialogRows.add()) {
				if (!cRoot) {
					staticTexts.add({staticLabel:"Copier le groupe de styles de caractres:"});
					staticTexts.add({staticLabel:" "});
				}
				else {
					staticTexts.add({staticLabel:"Styles de caractres"});
					staticTexts.add({staticLabel:" "});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var charGroup = dropdowns.add({stringList:cGroupNames, selectedIndex:cSel, minWidth:220});
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:40});
						staticTexts.add({staticLabel:"Le nom du nouveau groupe:"});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:40});
						var charName = textEditboxes.add({editContents:newCharGroupName, minWidth:224});
						staticTexts.add({staticLabel:" "});
					}
					if (cRoot) {
						var cButtons = radiobuttonGroups.add();
						with (cButtons) {
							radiobuttonControls.add({staticLabel:"*copier* les styles dans le nouveau groupe", checkedState:cCop});
							radiobuttonControls.add({staticLabel:"*dplacer* les styles dans le nouveau groupe", checkedState:cMov});
						}
					}
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"La nouvelle langue:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var langName = dropdowns.add({stringList:locLangList, selectedIndex:curLang, minWidth:50});
				var fButtons = radiobuttonGroups.add();
				with (fButtons) {
					radiobuttonControls.add({staticLabel:"Conserver la dfinition \"[Aucune langue]\"", checkedState:nFrc});
					radiobuttonControls.add({staticLabel:"Remplacer la dfinition \"[Aucune langue]\"", checkedState:dFrc});
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Le calque  copier:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var layerName = dropdowns.add({stringList:allLayers, selectedIndex:curLayer, minWidth:220});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" ", minWidth:40});
					staticTexts.add({staticLabel:"Le nom et la couleur du nouveau calque cible:"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" ", minWidth:40});
					var layerBox = textEditboxes.add({editContents:newLayerName, minWidth:224});
					staticTexts.add({staticLabel:" "});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" ", minWidth:40});
					var layerColor = dropdowns.add({stringList:layerColors, selectedIndex:newLayerColorID, minWidth:240});
					
				}
			}
		}
	}
}
// afficher le dialogue
if (aDialog.show() == true) {
	// reprendre le choix de l'utilisateur
	var newParaGroupName = "";
	if (noParaStyles == false) {
		var paraID = paraGroup.selectedIndex;
		newParaGroupName = paraName.editContents;
		if (pRoot) {
			var pLabel = pButtons.selectedButton;
			var pBtn = pLabel;
			if (pBtn == 0) {
				pCop = true;
			}
			else if (pBtn == 1) {
				pCop = false;
			}
		}
	}
	var newCharGroupName = "";
	if (noCharStyles == false) {
		var charID = charGroup.selectedIndex;
		newCharGroupName = charName.editContents;
		if (cRoot) {
			var cLabel = cButtons.selectedButton;
			var cBtn = cLabel;
			if (cBtn == 0) {
				cCop = true;
			}
			else if (cBtn == 1) {
				cCop = false;
			}
		}
	}
	var dialogIndex = langName.selectedIndex;
	var nLangs = lngNameList.length;
	for (var i=0; i<nLangs; i++) {
		if (lngNameList[i] == locLangList[dialogIndex]) {
			var newLang = i;
			break;
		}
	}
	var fLabel = fButtons.selectedButton;
	var fBtn = fLabel;
	if (fBtn == 0) {
		nFrc = true;
	}
	else if (fBtn == 1) {
		nFrc = false;
	}
	var sourceLayer = layerName.selectedIndex;
	var newLayerName = layerBox.editContents;
	var selCol = layerColor.selectedIndex;
	// den Dialog aus dem Speicher entfernen
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// die Wahl des Anwenders testen
var paraOK = false;
var oldPara = "";
if (noParaStyles == false) {
	var paraNames = curDoc.paragraphStyles.everyItem().name;
	var allPNames = paraNames.concat(pGroupNames);
	if (paraID != 0) {
		if (newParaGroupName != "" && newParaGroupName != " ") {
			for (var p=1; p<allPNames.length; p++) {
				if (allPNames[p] == newParaGroupName) {
					alert (newParaGroupName + "\nCe nom de groupe (ou de style de paragraphe)\nexiste dj. Un nouvel essai, s.v.p.", "Stop");
					exit();
				}
			}
			paraOK = true;
			oldPara = pGroupNames[paraID];
		}
		else {
			alert ("Il faut entrer un nom pour le groupe de styles de paragraphes.", "Stop");
			exit();
		}
	}
}
var charOK = false;
var oldChar = "";
if (noCharStyles == false) {
	var charNames = curDoc.characterStyles.everyItem().name;
	var allCNames = charNames.concat(cGroupNames);
	if (charID != 0) {
		if (newCharGroupName != "" && newCharGroupName != " ") {
			for (var c=0; c<allCNames.length; c++) {
				if (allCNames[c] == newCharGroupName) {
					alert (newCharGroupName + "\nCe nom de groupe (ou de style de caractres)\nexiste dj. Un nouvel essai, s.v.p.", "Stop");
					exit();
				}
			}
			charOK = true;
			oldChar = cGroupNames[charID];
		}
		else {
			alert ("Il faut entrer un nom pour le groupe de styles de caractres.", "Stop");
			exit();
		}
	}
	if (newLayerName != "" && newLayerName != " ") {
		for (var n=0; n<allLayers.length; n++) {
			if (allLayers[n] == newLayerName) {
				alert (newLayerName + "\nCe nom de calque existe dj.\nUn nouvel essai, s.v.p.", "Stop");
				exit();
			}
		}
	}
	else {
		alert ("Il faut entrer un nom pour le groupe de styles de caractres.", "Stop");
		exit();
	}
}

// crire dans le fichier: le groupe source style de paragraphes, le nouveau groupe, copier, 
// le groupe source style de caractres, copier, la langue, conserver la langue "[Aucune langue]"
if (paraOK || charOK) {
	var defArr = new Array(oldPara, newParaGroupName, pCop, oldChar, newCharGroupName, cCop, dialogIndex, nFrc, sourceLayer, newLayerName, selCol);
	var langDef = defArr.join("\n");
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/LangCopyGroup_506.txt");
	}
	else {
		var f = new File("~/Library/Preferences/LangCopyGroup_506.txt");
	}
	fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(langDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// dupliquer le calque slectionn, le nommer, appliquer la couleur
var targetLayer = curDoc.layers[sourceLayer].duplicate();
targetLayer.name = newLayerName;
targetLayer.layerColor = uiColors[selCol];

// copier le(s) groupe(s) correspondant(s) et le(s) renommer
// d'abord le groupe de style de paragraphe
if (paraOK) {
	try {
		if (paraGroups[paraID-1] == "[Root]") {
			var newParaGroup = curDoc.paragraphStyleGroups.add();
			newParaGroup.name = newParaGroupName;
			var curPara, newPara, oldName, nChars;
			for (var p=nAllPara-1; p>-1; p--) {
				curPara = allParaStyles[p];
				if (curPara.name[0] != "[") {
					try {
						if (pCop) {
							nChars = curPara.name.length;
							newPara = curPara.duplicate();
							oldName = newPara.name.slice(0, nChars);
							newPara.move(LocationOptions.AT_BEGINNING, newParaGroup);
							newPara.name = oldName;
						}
						else {
							curPara.move(LocationOptions.AT_BEGINNING, newParaGroup);
						}
					}
					catch(e) {
					}
				}
			}
		}
		else {
			var newParaGroup = curDoc.paragraphStyleGroups[paraID-1].duplicate();
			newParaGroup.name = newParaGroupName;
		}
	}
	catch (e) {
	}
}
// puis le groupe de style de caractres
if (charOK) {
	try {
		if (charGroups[charID-1] == "[Root]") {
			var newCharGroup = curDoc.characterStyleGroups.add();
			newCharGroup.name = newCharGroupName;
			var curChar, newChar, oldName, nChars;
			for (var p=nAllChar-1; p>-1; p--) {
				curChar = allCharStyles[p];
				if (curChar.name[0] != "[") {
					try {
						if (cCop) {
							nChars = curChar.name.length;
							newChar = curChar.duplicate();
							oldName = newChar.name.slice(0, nChars);
							newChar.move(LocationOptions.AT_BEGINNING, newCharGroup);
							newChar.name = oldName;
						}
						else {
							curChar.move(LocationOptions.AT_BEGINNING, newCharGroup);
						}
					}
					catch(e) {
					}
				}
			}
		}
		else {
			var newCharGroup = curDoc.characterStyleGroups[charID-1].duplicate();
			newCharGroup.name = newCharGroupName;
		}
	}
	catch (e) {
	}
}

// changer la langue des styles de paragraphes
if (paraOK) {
	var curGroup = curDoc.paragraphStyleGroups.item(newParaGroupName);
	var curParaStyles = curGroup.allParagraphStyles;
	var nParaStyles = curParaStyles.length;
	var curStyle;
	for (var k=0; k<nParaStyles; k++) {
		try {
			curStyle = curParaStyles[k];
			if (curStyle.appliedLanguage.name[0] == "[") {
				if (!nFrc) {
					curStyle.appliedLanguage = allLang[newLang];
				}
			}
			else {
				curStyle.appliedLanguage = allLang[newLang];
			}
		}
		catch (e) {
		}
	}
}

// changer aussi la langue des styles de caractres
if (charOK) {
	var curGroup = curDoc.characterStyleGroups.item(newCharGroupName);
	var curCharStyles = curGroup.allCharacterStyles;
	var nCharStyles = curCharStyles.length;
	var curStyle;
	for (var k=0; k<nCharStyles; k++) {
		try {
			curStyle = curCharStyles[k];
			if (curStyle.appliedLanguage.name[0] == "[") {
				if (!nFrc) {
					curStyle.appliedLanguage = allLang[newLang];
				}
			}
			else {
				curStyle.appliedLanguage = allLang[newLang];
			}
		}
		catch (e) {
		}
	}
}

// une boucle  travers les paragraphes et remplacer les styles 
// de paragraphes par ceux du groupe copi
var allCells;
var allCParas;
var allParas;
var allTables;
var allTsr;
var curCharName;
var curFrame;
var curParaName;
var curStory;
var curStyle;
var nCells;
var nCParas;
var nTables;
var nTsr;
var probPCtr = 0;
var probCCtr = 0;

var allFrames = curDoc.layers.itemByName(newLayerName).allPageItems;
var nFrames = allFrames.length;

for (var f=0; f<nFrames; f++) {
	curFrame = allFrames[f];
	if (curFrame.constructor.name == "TextFrame") {
		if (curFrame.previousTextFrame == null) {
			changeStyle(curFrame);
		}
	}
}

var allMasters = curDoc.masterSpreads;
var nMasters = allMasters.length;

for (var m=0; m<nMasters; m++) {
	allFrames = allMasters[m].allPageItems;
	nFrames = allFrames.length;
	for (var f=0; f<nFrames; f++) {
		curFrame = allFrames[f];
		if (curFrame.itemLayer == curDoc.layers.itemByName(newLayerName)) {
			if (curFrame.constructor.name == "TextFrame") {
				if (curFrame.previousTextFrame == null) {
					changeStyle(curFrame);
				}
			}
		}
	}
}

function changeStyle(curFrame) {
	curStory = curFrame.parentStory;
	if (paraOK) {
		allParas = curStory.paragraphs;
		nParas = allParas.length;
		paraStyles = allParas.everyItem().appliedParagraphStyle;
		for (var p=0; p<nParas; p++) {
			curParaName = paraStyles[p].name;
			if (curParaName[0] == "[") {
				if (allParas[p].appliedLanguage.name[0] == "[") {
					if (!nFrc) {
						allParas[p].appliedLanguage = allLang[newLang];
					}
				}
				else {
					allParas[p].appliedLanguage = allLang[newLang];
				}
			}
			else {
				try {
					curStyle = curDoc.paragraphStyleGroups.item(newParaGroupName).paragraphStyles.item(curParaName);
					allParas[p].appliedParagraphStyle = curStyle;
				}
				catch (e) {
					probPCtr++;
				}
			}
		}
		allTables = curStory.tables;
		nTables = allTables.length;
		for (var t=0; t<nTables; t++) {
			allCells = allTables[t].cells;
			nCells = allCells.length;
			for (var c=0; c<nCells; c++) {
				allCParas = allCells[c].paragraphs;
				nCParas = allCParas.length;
				cParaStyles = allCParas.everyItem().appliedParagraphStyle;
				for (var cp=0; cp<nCParas; cp++) {
					curParaName = cParaStyles[cp].name;
					if (curParaName[0] == "[") {
						allCParas[cp].appliedLanguage = allLang[newLang];
					}
					else {
						try {
							curStyle = curDoc.paragraphStyleGroups.item(newParaGroupName).paragraphStyles.item(curParaName);
							allCParas[cp].appliedParagraphStyle = curStyle;
						}
						catch (e) {
							probPCtr++;
						}
					}
				}
				if (charOK) {
					allCTsr = allCells[c].textStyleRanges;
					nCTsr = allCTsr.length;
					charStyles = allCTsr.everyItem().appliedCharacterStyle;
					for (var ct=nCTsr-1; ct>-1; ct--) {
						curCharName = charStyles[ct].name;
						if (curCharName[0] != "[") {
							try {
								curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
								allCTsr[ct].appliedCharacterStyle = curStyle;
							}
							catch (e) {
								probCCtr++;
							}
						}
					}
				}
			}
		}
		allFootNotes = curStory.footnotes;
		nNotes = allFootNotes.length;
		for (var n=0; n<nNotes; n++) {
			allNParas = allFootNotes[n].paragraphs;
			nNParas = allNParas.length;
			fParaStyles = allNParas.everyItem().appliedParagraphStyle;
			for (var np=0; np<nNParas; np++) {
				curParaName = fParaStyles[np].name;
				if (curParaName[0] == "[") {
					allNParas[np].appliedLanguage = allLang[newLang];
				}
				else {
					try {
						curStyle = curDoc.paragraphStyleGroups.item(newParaGroupName).paragraphStyles.item(curParaName);
						allNParas[np].appliedParagraphStyle = curStyle;
					}
					catch (e) {
						probPCtr++;
					}
				}
			}
			if (charOK) {
				allNTsr = allFootNotes[n].textStyleRanges;
				nNTsr = allNTsr.length;
				charStyles = allNTsr.everyItem().appliedCharacterStyle;
				for (var nt=nNTsr-1; nt>-1; nt--) {
					curCharName = charStyles[nt].name;
					if (curCharName[0] != "[") {
						try {
							curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
							allNTsr[nt].appliedCharacterStyle = curStyle;
						}
						catch (e) {
							probCCtr++;
						}
					}
				}
			}
		}
	}
	if (charOK) {
		allTsr = curStory.textStyleRanges;
		nTsr = allTsr.length;
		charStyles = allTsr.everyItem().appliedCharacterStyle;
		for (var t=nTsr-1; t>-1; t--) {
			curCharName = charStyles[t].name;
			if (curCharName[0] != "[") {
				try {
					curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
					allTsr[t].appliedCharacterStyle = curStyle;
				}
				catch (e) {
					probCCtr++;
				}
			}
		}
	}
	if (!paraOK && charOK) {
		allTables = curStory.tables;
		nTables = allTables.length;
		for (var t=0; t<nTables; t++) {
			allCells = allTables[t].cells;
			nCells = allCells.length;
			for (var c=0; c<nCells; c++) {
				allCTsr = allCells[c].textStyleRanges;
				nCTsr = allCTsr.length;
				charStyles = allCTsr.everyItem().appliedCharacterStyle;
				for (var ct=nCTsr-1; ct>-1; ct--) {
					curCharName = charStyles[ct].name;
					if (curCharName[0] != "[") {
						try {
							curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
							allCTsr[ct].appliedCharacterStyle = curStyle;
						}
						catch (e) {
							probCCtr++;
						}
					}
				}
			}
		}
		allFootNotes = curStory.footnotes;
		nNotes = allFootNotes.length;
		for (var n=0; n<nNotes; n++) {
			allNTsr = allFootNotes[n].textStyleRanges;
			nNTsr = allNTsr.length;
			charStyles = allNTsr.everyItem().appliedCharacterStyle;
			for (var nt=nNTsr-1; nt>-1; nt--) {
				curCharName = charStyles[nt].name;
				if (curCharName[0] != "[") {
					try {
						curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
						allNTsr[nt].appliedCharacterStyle = curStyle;
					}
					catch (e) {
						probCCtr++;
					}
				}
			}
		}
	}
}

// annoncer la fin de l'action
if (probPCtr == 0 && probCCtr == 0) {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
	dlog.show();
	// une petite pause
	$.sleep(999);
	// fermer la fentre
	dlog.close();
}
else if (probPCtr > 0 && probCCtr > 0) {
	alert ("Les styles non changs dans le texte\nStyles de paragraphes: " + probPCtr + "\nZeichenformate: " + probCCtr);
}
else if (probPCtr > 0 && probCCtr == 0) {
	alert ("Styles de paragraphes\nnon changs dans le texte: " + probPCtr);
}
else if (probPCtr == 0 && probCCtr > 0) {
	alert ("Styles de caractres\nnon changs dans le texte: " + probCCtr);
}